/* ---------------------------------------------------------------------- *\
  seg-rx.c

  A test program for the generation of SEGV

  Eunil Won, Korea University
 
  $Id: seg-ttrx.c,v 1.1.1.1 2005/02/23 09:44:12 ttrx Exp $
  $Log: seg-ttrx.c,v $
  Revision 1.1.1.1  2005/02/23 09:44:12  ttrx
  First into cvs


  2004091301  re-written for the devive driver 
\* ---------------------------------------------------------------------- */

#define VERSION 2005011500
#define TTRX_MAX_LENGTH 0x450
#define TTRX_DEV_HEAD "/dev/ttrx"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "ttrxlib.h"

/* ---------------------------------------------------------------------- *\
   main
\* ---------------------------------------------------------------------- */
int
main(int argc, char **argv)
{
  unsigned int base_plx;
  unsigned int base_rx = 0;
  unsigned int *ptr_plx;
  unsigned int *ptr_rx;
  int size_plx  = 256;
  int size_rx = 4096;
  int readfifo = 0;
  int summaryonly = 0;
  int rxid = 0;

  int fd;
  int nread, nwritten, base[((TTRX_MAX_LENGTH)>>2)+1];
  int regs;
  int base_new[((TTRX_MAX_LENGTH)>>2)+1];
  char ttrx_dev_name[64];

  while (argc > 1) {
    if (strncmp(argv[1], "-b", 2) == 0) {
      base_rx = strtoul(argv[2], 0, 16);
      argc--, argv++;
    } else if (strncmp(argv[1], "-f", 2) == 0) {
      readfifo = ! readfifo;
    } else if (strncmp(argv[1], "-s", 2) == 0) {
      summaryonly = ! summaryonly;
    } else if (argv[1][0] == '-' && isdigit(argv[1][1])) {
      rxid = argv[1][1] - '0';
    } else {
      printf("usage: dump-rx [-<n>] [-f] [-b <base>]\n");
      printf("options:\n");
      printf(" -<n>       select <n>-th TT-RX (<n>=0,1,2...9)\n");
      printf(" -f           read fifo\n");
      printf(" -s           summary only\n");
      printf(" -b <base>    set base address (in hex)\n");
      return 1;
    }
    argc--, argv++;
  }

  sprintf(ttrx_dev_name,TTRX_DEV_HEAD"%d",rxid);

  if ((fd = open(ttrx_dev_name,O_RDWR)) < 0) 
  {
    printf("TT-RX is not found.\n");
    exit(1);
  }

  printf("%d \n",lseek(fd,0x10000,SEEK_SET));
  nread = read(fd,base,4);

  close(fd);
  return 0;
}
